<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />

  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css" integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">

  <title>Exploring United Nations Migrant Stock Data With the untools Package</title>
  <style>
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>

  <style>
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(data-line-number);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>

  <link rel="stylesheet" href="/usr/local/lib/R/site-library/danteSubmit/rmarkdown/templates/dante_vignette/resources/style.css" />

  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>

<body>

<header id="title-block-header">
<h1 class="title">Exploring United Nations Migrant Stock Data With the <em>untools</em> Package</h1>

<p class="date" id="date"><em>2019-09-10</em></p>

<div id="author-block">
<span id="author-name">Joshua Brinks</span>,&nbsp;<span id="author-affiliation"><em>ISciences, LLC</em>&nbsp;<sup><a id="author-email" href="mailto:jbrinks@isciences.com"><i class="far fa-envelope" style="font-size:15px; color: blue"></i></a></sup></br>
</div>

<div id="vignette-highlights-block">
<h3> Highlights: </h3>
<ul>
<li>untools automates retrieval and cleanup of migrant stock data not designed for analysis.</li>
<li>Provides multiple automated visualizations</li>
</ul>
</div>



</header>

<h3> Contents: </h3>
<nav id="TOC" role="doc-toc">
<ul>
<li><a href="#introduction"><span class="toc-section-number">1</span> Introduction</a></li>
<li><a href="#acquiring-the-data"><span class="toc-section-number">2</span> Acquiring the Data</a></li>
<li><a href="#the-getunstock17-function"><span class="toc-section-number">3</span> The getunstock17 Function</a></li>
<li><a href="#visualizing-un-stock-data"><span class="toc-section-number">4</span> Visualizing UN Stock Data</a></li>
<li><a href="#references">References</a></li>
</ul>
</nav>

<div id="introduction" class="section level1">
<h1><span class="header-section-number">1</span> Introduction</h1>
<p>In addition to the <a href="http://popstats.unhcr.org/en/overview">Population Statistics</a>, the United Nations provides additional data sets detailing international migrant statistics through the <a href="http://www.un.org/en/development/desa/population/">Department of Economic and Social Affairs: Population Division</a>. The most widely used dataset is the <a href="https://www.un.org/en/development/desa/population/migration/data/estimates2/estimates17.shtml">International Migrant Stock</a>. This data is featured in several recent academic papers; one of the more prominent examples is Guy Abel’s <em>Quantifying Global International Migration Flows</em> <span class="citation">(Abel and Sander <a href="#ref-Abel2014">2014</a>)</span>. The most recent version is entitled the <em>The 2017 Revision</em>, and is available by total international migrant stocks, by age and sex, and by destination and origin. For this vignette we will focus on the destination and origin version.</p>
</div>
<div id="acquiring-the-data" class="section level1">
<h1><span class="header-section-number">2</span> Acquiring the Data</h1>
<p>The <em>International Migrant Stock: 2017 Revision by Destination and Origin Country</em> is available by direct download link <a href="https://www.un.org/en/development/desa/population/migration/data/estimates2/data/UN_MigrantStockByOriginAndDestination_2017.xlsx">here</a>. Unlike the UNHCR Population Statistics time series data featured in our <em>Exploring United Nations Refugee &amp; Asylum Data With the untools Package</em> vignette, the migrant stock data is not analysis-ready. The data is organized for viewability in complex Microsoft Excel spreadsheets. The data is organized in matrices with multiple aggregations listed together, complex headers, and spread across several tabs:</p>
<div class="figure">
<img src="migrant_stock_ss.PNG" alt="Screen shot containing UN Migrant Stock data. Large headers, offset matrices, multiple aggregations, multiple tabs…" />
<p class="caption">Screen shot containing UN Migrant Stock data. Large headers, offset matrices, multiple aggregations, multiple tabs…</p>
</div>
</div>
<div id="the-getunstock17-function" class="section level1">
<h1><span class="header-section-number">3</span> The getunstock17 Function</h1>
<p>The <em>untools</em> package can streamline the acquisition and processing of UN migrant stock data using the <code>getunstock17()</code> function. The <code>getunstock17()</code> function will automatically retrieve the dataset over http, remove aggregations above the national level, remove unnecessary columns for analysis, introduce ISO country codes, and melt the matrix into long form.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb1-1" data-line-number="1">stocks&lt;-<span class="kw">getunstock17</span>()</a></code></pre></div>
<table>
<thead>
<tr>
<th style="text-align:left;">
host_iso
</th>
<th style="text-align:left;">
stock_iso
</th>
<th style="text-align:right;">
year
</th>
<th style="text-align:right;">
value
</th>
<th style="text-align:left;">
host
</th>
<th style="text-align:left;">
stock
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
1990
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
1995
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
2000
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
2005
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
2010
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
2015
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
2017
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
DZA
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
1990
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Algeria
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
DZA
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
1995
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Algeria
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
<tr>
<td style="text-align:left;">
DZA
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:right;">
2000
</td>
<td style="text-align:right;">
0
</td>
<td style="text-align:left;">
Algeria
</td>
<td style="text-align:left;">
Afghanistan
</td>
</tr>
</tbody>
</table>
<p>Additionally, the <code>getunstock17()</code> function provides arguments to return the data in wide form <code>wide = TRUE</code>, and filter data by year with <code>range = c(2000, 2017)</code>. Migrant stock data is available in 5 year intervals plus the year of revision (2017) starting from 1990. By default the <code>getunstock17()</code> function includes all data. Viewing data in wide format can be convenient for viewing time series data outside of a figure. Because the <code>getunstock17()</code> function automatically retrieves the Excel spreadsheet from the UN server, it’s advisable to acquire the data using the default settings and perform additional subsetting or casting into wide format using base R, <code>dplyr</code>, <code>data.table</code>, and <code>reshape2</code>. If you don’t have internet connectivity or already have the Excel spreadsheet in your home directory you can utilise the <code>prepunstock17()</code> function. This will scan the home directory for the Excel file delivered by the United Nations website and process the file as described above.</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb2-1" data-line-number="1">stocks&lt;-<span class="kw">getunstock17</span>()</a></code></pre></div>
</div>
<div id="visualizing-un-stock-data" class="section level1">
<h1><span class="header-section-number">4</span> Visualizing UN Stock Data</h1>
<p>The <code>untools</code> package provides several default plotting function designed to create modern visualizations for static or time series UN migrant stock data. By default <code>untools</code> will plot a time series of migrant stocks for the 5 greatest populations in the final year. For convenience, the <code>plot()</code> function will automatically adjust the color palette, title, and subtitle based on the chosen country and the number of positive stock populations for the given time period. With no additional arguments the default plotting function will produce a time series of the top 5 stock populations in 2017 for the United States:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb3-1" data-line-number="1">usa.stocks&lt;-<span class="kw">plot</span>(stocks)</a></code></pre></div>
<p><img src="exploring-unstocks17_files/figure-html/unnamed-chunk-5-1.png" width="672" /></p>
<p>You can specify additional countries using the <code>country =</code> argument. Lets view stock populations in Russia.</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb4-1" data-line-number="1">rus.stocks&lt;-<span class="kw">plot</span>(stocks, <span class="dt">country =</span> <span class="st">&#39;RUS&#39;</span>)</a></code></pre></div>
<p><img src="exploring-unstocks17_files/figure-html/unnamed-chunk-6-1.png" width="672" /></p>
<p>Lastly, you can view a static barplot for a given year using the <code>mode = 'static</code> and <code>yr =</code> arguments. Let’s plot the top stock population in Italy during 2005.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb5-1" data-line-number="1">ita.static.stocks&lt;-<span class="kw">plot</span>(stocks, <span class="dt">country =</span> <span class="st">&#39;ITA&#39;</span>, <span class="dt">mode =</span> <span class="st">&#39;static&#39;</span>, <span class="dt">yr=</span><span class="dv">2005</span>)</a></code></pre></div>
<p><img src="exploring-unstocks17_files/figure-html/unnamed-chunk-7-1.png" width="672" /></p>
</div>
<div id="references" class="section level1 unnumbered">
<h1>References</h1>
<div id="refs" class="references">
<div id="ref-Abel2014">
<p>Abel, Guy J., and Nikola Sander. 2014. “Quantifying Global International Migration Flows.” <em>Science</em> 343 (6178): 1520–2. <a href="https://doi.org/10.1126/science.1248676">https://doi.org/10.1126/science.1248676</a>.</p>
</div>
</div>
</div>

<footer>

<h1> Additional Meta-Data </h1>

<div id="related-packages-block">
<h3> Related Packages: </h3>
<ul>
<li>untools</li>
</ul>
</div>

<div id="related-datasets-block">
<h3> Related Data Sets: </h3>
<ul>
<li>United Nations’ Trends in International Migrant Stock: The 2017 Revision</li>
</ul>
</div>

<div id="data-presentation-forms-block">
<h3> Data Categories:</h3>
<span id="data-presentation-forms">tabular, wide form dyadic</span>
</div>

<div id="related-vignettes-block">
<h3> Related Vignettes: </h3>
<ul>
<li>Related Dante Vignette</li>
</ul>
</div>

</footer>

</body>

</html>
